#!/usr/bin/env bash

SETTING_CONG_PATH="/var/packages/ActiveBackup/target/etc/setting.conf"
REPO_VOLUME=$(/bin/cat ${SETTING_CONG_PATH} | /bin/jq -r -e '.conf_repo_volume_path')

if [ $? -ne 0 ];then
	exit 0
fi

CA_DIR="${REPO_VOLUME}/@ActiveBackup/cert_dir/"
CA_FILE="${CA_DIR}ca.crt"

if [ ! -f ${CA_FILE} ] ; then
	exit 0
fi

## Actions
HASH_VALUE=$(openssl x509 -noout -hash -in ${CA_FILE} 2>/dev/null )

chmod 755 ${CA_DIR}
rm -f ${CA_DIR}*.0 #remove old link
chmod 644 ${CA_FILE}
ln -sf ${CA_FILE} "${CA_DIR}${HASH_VALUE}.0"

exit 0
