#-*-coding: utf-8 -*-

import os
import errno

class GuestOSException(OSError):
    def __init__(self, *args, **kwargs):
        self.address = kwargs.pop('address', None)
        super(GuestOSException, self).__init__(*args, **kwargs)

class GuestOSAttributeError(GuestOSException):
    def __init__(self, *args, **kwargs):
        self.miss_attr_list = kwargs.pop('miss_attr_list', [])
        super(GuestOSAttributeError, self).__init__(*args, **kwargs)

class PowerShellException(Exception):
    def __init__(self, *args, **kwargs):
        category_info = kwargs.pop('category_info', {})
        error_id = kwargs.pop('error_id', '')
        for key in category_info:
            setattr(self, key, category_info[key])
        setattr(self, 'error_id', error_id)
        super(PowerShellException, self).__init__(*args, **kwargs)

class LocalStatFail(OSError):
    pass

class AuthenticateError(Exception):
    pass

class InvalidArgument(ValueError):
    pass

class EntityNotFound(Exception):
    pass

class CodePageNotFound(Exception):
    pass

class PathRestoreNotSupport(Exception):
    pass

class VirtualDiskNotFound(EntityNotFound):
    def __init__(self, *args, **kwargs):
        self.id = kwargs.pop('id', None)
        super(VirtualDiskNotFound, self).__init__(*args, **kwargs)

class OperationTimeoutError(Exception):
    pass

class CerticateVerifiedError(Exception):
    def __init__(self, *args, **kwargs):
        self.certificate = kwargs.pop('certificate', None)
        super(CerticateVerifiedError, self).__init__(*args, **kwargs)

class Cancel(Exception):
    def __init__(self, *args, **kwargs):
        super(Cancel, self).__init__(*args, **kwargs)
